//  ----------------------------------------------------------------------
// | Open Archives Initiative Repository Explorer - version 2.0b2-1.44    |
// | Hussein Suleman                                                      |
// | May 2002                                                             |
//  ----------------------------------------------------------------------
// |  Virginia Polytechnic Institute and State University                 |
// |  Department of Computer Science                                      |
// |  Digital Library Research Laboratory                                 |
//  ----------------------------------------------------------------------

// ======================================================================
//  Module     : config
//  Purpose    : Configuration variables
// ======================================================================

#ifndef _CONFIG_
#define _CONFIG_


// repository explorer configuration
#define reversion "1.0"
#define redate "September 2002"
#define reprotocolversion "odl"
#define reallprotocolversions "1.0/1.1/2.0/" \
                               reprotocolversion


// variables that probably need to be configured
#define physicalpath "/home/odl/public_html/cgi-bin/odl-re/"
#define urlpath "http://oai.dlib.vt.edu/~odl/cgi-bin/odl-re/"
#define pythonpath "/usr/local/bin/python"


// local schema files
#define local10schema "http://oai.dlib.vt.edu/OAI/1.0/"
#define local11schema "http://oai.dlib.vt.edu/OAI/1.1/"
#define local20schema "http://oai.dlib.vt.edu/OAI/2.0/"


// paths to main CGI programs
#define testodl urlpath \
                "testodl"
#define addarchive urlpath \
                   "addarchive"
#define about urlpath \
              "about"


// directory with OAI logo
#define oaiimageprefix "http://oai.dlib.vt.edu/images/"


// path to the lynx program or substitute for loading URLs
#define lynxpath physicalpath \
                 "lynx.pl"

// path to the comply program to check OAI compliance
#define complyoai20path physicalpath \
                   "complyoai20"
#define complyoai11path physicalpath \
                   "complyoai11"
#define complyxoai10path physicalpath \
                   "complyxoai10"

// path to the XSV program to perform schema validation
#define oldxsvpath pythonpath \
                   " " \
                   physicalpath \
                   "oldxsv/applyschema.py"
#define xsvpath pythonpath \
                " " \
                physicalpath \
                "xsv/applyschema.py"


// prefix before all OAI namespaces
#define namespaceprefix_1_0 "http://www.openarchives.org/OAI/1.0/OAI_"
#define namespaceprefix_1_1 "http://www.openarchives.org/OAI/1.1/OAI_"
#define namespaceprefix_2_0 "http://www.openarchives.org/OAI/2.0/"

// prefix before all remote OAI schemas
#define remoteschemaprefix_1_0 "http://www.openarchives.org/OAI/1.0/OAI_"
#define remoteschemaprefix_1_1 "http://www.openarchives.org/OAI/1.1/OAI_"
#define remoteschemaprefix_2_0 "http://www.openarchives.org/OAI/2.0/"

// prefix before all local OAI schemas
#define localschemaprefix_1_0 local10schema \
                              "OAI_"
#define localschemaprefix_1_1 local11schema \
                              "OAI_"
#define localschemaprefix_2_0 local20schema 


// default background color
#define bgcolorpreset "aaffaa"

// default color for headings
#define headercolorpreset "00cc00"

// default background color for options
#define blockcolorpreset "ffcccc"


// path to the Xerces program to perform schema validation
#define xercespath physicalpath \
                   "xerces/validate.sh"


#endif
