//  ----------------------------------------------------------------------
// | Open Archives Initiative Repository Explorer - version 1.0-1.1       |
// | Hussein Suleman                                                      |
// | April 2001                                                           |
//  ----------------------------------------------------------------------
// |  Virginia Polytechnic Institute and State University                 |
// |  Department of Computer Science                                      |
// |  Digital Libraries Research Laboratory                               |
//  ----------------------------------------------------------------------

// ======================================================================
//  Module     : escape
//  Purpose    : Perform XML escaping
// ======================================================================

#include <iostream.h>
#include <string.h>

// ----------------------------------------------------------------------
//  Function   : Escape
// ----------------------------------------------------------------------
//  Purpose    : Escapes and outputs strings with <>&
//  Parameters : string to output
//  Result     : None
// ----------------------------------------------------------------------

void Escape ( char *s )
{
   long int i = 0;
   while (s[i] != 0)
   {
      if (s[i] == '<')
         cout << "&lt;";
      else if (s[i] == '>')
         cout << "&gt;";
      else if ((s[i] == '&') && (s[i+1] != 0) && (s[i+1] != '#')) 
         cout << "&amp;";
      else
         cout << s[i];
      i++;
   }
}

// ----------------------------------------------------------------------
//  Function   : EscapeHTML
// ----------------------------------------------------------------------
//  Purpose    : Escapes and outputs CGI strings
//  Parameters : string to output
//  Result     : output string pointer
// ----------------------------------------------------------------------

char *EscapeHTML ( char *s )
{
   static char output[2048];
   output[0] = 0;
   long int i = 0;
   while (s[i] != 0)
   {
      if (s[i] == '/')
         strcat (output, "%2F");
      else if (s[i] == '?')
         strcat (output, "%3F");
      else if (s[i] == '#')
         strcat (output, "%23");
      else if (s[i] == '=')
         strcat (output, "%3D");
      else if (s[i] == '&')
         strcat (output, "%26");
      else if (s[i] == ':')
         strcat (output, "%3A");
      else if (s[i] == ';')
         strcat (output, "%3B");
      else if (s[i] == ' ')
         strcat (output, "%20");
      else if (s[i] == '%')
         strcat (output, "%25");
      else if (s[i] == '+')
         strcat (output, "%2B");
      else if (s[i] == 13)
         strcat (output, "%0D");
      else if (s[i] == 10)
         strcat (output, "%0A");
      else if (s[i] == 34)
         strcat (output, "%22");
      else if (s[i] == 96)
         strcat (output, "%60");
      else
      {
         char t[2];
         t[0] = s[i];
         t[1] = 0;
         strcat (output, t);
      }
      i++;
   }
   return output;
}
