# Copyright (C) 2000 LTG -- See accompanying COPYRIGHT and COPYING files
# TODO: raise some errors on bogus patterns!
import string
import types
import XML

class XPath:
  def __init__(self,str):
    self.str=str
    self.pats=self.parse(str)

  def parse(self,str):
    disjuncts=map(lambda s:string.split(s,'/'),string.split(str,'|'))
    # weird result for //
    return map(lambda d,ss=self:map(lambda p,s=ss:s.patBit(p),
                                    d),
               disjuncts)

  def patBit(self,part):
    # TODO: handle namespaces
    if part=='':
      # // in string
      return None
    elif part=='.':
      return lambda e:[e]
    elif part[0]=='@':
      return lambda e,y=None,s=self,a=part[1:]:s.attrs(e,a,y)
    else:
      b=string.find(part,'[')
      if b>-1:
        f=string.find(part,']')
        return lambda e,y=None,s=self,n=part[0:b],m=self.patBit(part[b+1:f]):s.children(e,n,y,m)
      else:
        return lambda e,y=None,s=self,n=part:s.children(e,n,y)

  def find(self,element):
    res=[]
    for pat in self.pats:
      sub=self.process(element,pat)
      if sub:
        res=res+sub
    if res:
      return res
    else:
      return None

  def find1(self,nodelist,pat):
    res=[]
    for e in nodelist:
      sub=self.process(e,pat)
      if sub:
	res=res+sub
    if res:
      return res
    else:
      return None

  def process(self,element,pat):
    pe=pat[0]
    if pe:
      res=pe(element)
    elif len(pat)>1:
      # None means descendant, side effect of split is two Nones in first place
      if pat[1]:
        pat=pat[1:]
      elif len(pat)>2:
        pat=pat[2:]
      else:
        # bogus pattern ending in //
        return None
      if pat[0]:
        res=pat[0](element,1)
      else:
        # bogus pattern -- ///?
        return None
    else:
      # bogus pattern ending in /
      return None
    if not res:
      return None
    if len(pat)>1:
      return self.find1(res,pat[1:])
    else:
      return res

  def attrs(self,element,aname,anywhere):
    # assume this is the end of the line
    if element.attrs.has_key(aname):
      res=[element.attrs[aname].value]
    else:
      res=None
    if anywhere:
      for c in element.children:
        if isinstance(c,XML.Element):
          sr=self.attrs(c,aname,1)
          if sr:
            if res:
              res=res+sr
            else:
              res=sr
    return res

  def children(self,element,cname,anywhere,subPat=None):
    # trickier, we need to stay in control
    # TODO: handle namespaces!!!
    res=[]
    for c in element.children:
      if isinstance(c,XML.Element):
        if c.local==cname:
          if (not subPat) or subPat(c):
            res.append(c)
        if anywhere:
          sr=self.children(c,cname,1,subPat)
          if sr:
            if res:
              res=res+sr
            else:
              res=sr
    if res:
      return res
    else:
      return None
